---
title: Firefox 64 for developers
slug: Mozilla/Firefox/Releases/64
tags:
  - '64'
  - Firefox
  - Mozilla
  - Release
---
<div>{{FirefoxSidebar}}</div>

<p class="summary">This article provides information about the changes in Firefox 64 that will affect developers. Firefox 64 was released on December 11, 2018.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>The <a href="/en-US/docs/Tools/Accessibility_inspector#Highlighting_of_UI_items">Accessibility info-bar</a> has been enhanced to include information about the color contrast ratio of text or images on the page ({{bug(1473037)}}).</li>
 <li><a href="/en-US/docs/Tools/Responsive_Design_Mode">Responsive Design Mode</a> device selection is now saved between sessions ({{bug(1248619)}}).</li>
 <li>Resources that are potentially affected by <a href="/en-US/docs/Mozilla/Firefox/Privacy/Tracking_Protection">Tracking Protection</a> are now <a href="/en-US/docs/">indicated</a> in the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> ({{bug(1333994)}}).</li>
 <li>The <a href="/en-US/docs/Tools/Web_Console">Web Console</a> got improvements around entering and evaluating code:
  <ul>
   <li><a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Autocomplete">Autocomplete</a> for Console expressions is now case-insensitive ({{bug(672733)}}).</li>
   <li>You can now step through the <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Command_history">Console expression history</a> with bash-like reverse search ({{bug(1024913)}}).</li>
   <li><a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter">Evaluated code</a> in the Console is now syntax-highlighted in both the input and output ({{bug(1463669)}}).</li>
  </ul>
 </li>
 <li>Stepping in the <a href="/en-US/docs/Tools/Debugger">JavaScript Debugger</a> also had some improvements:
  <ul>
   <li><a href="/en-US/docs/Tools/Debugger/How_to/Step_through_code">Stepping out</a> of a function in the Debugger now skips the return value ({{bug(923975)}}).</li>
  </ul>
 </li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>The Developer Tools GCLI has been removed ({{bug(1429421)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS">CSS</h3>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Scrollbars">CSS Scrollbars</a> spec functionality has been enabled by default ({{bug(1492012)}}).</li>
 <li>Interaction Media Features implemented, including <code><a href="/en-US/docs/Web/CSS/@media/pointer">pointer:coarse</a></code> ({{bug(1035774)}}). For <code><a href="/en-US/docs/Web/CSS/@media/any-pointer">any-pointer</a></code> and <code><a href="/en-US/docs/Web/CSS/@media/any-hover">any-hover</a></code> implementation, see {{bug(1483111)}}.</li>
 <li>The <code><a href="/en-US/docs/Web/CSS/@media/prefers-reduced-motion">prefers-reduced-motion</a></code> media feature is now supported in Firefox for Android ({{bug(1478505)}}).</li>
 <li>CSS {{cssxref("&lt;gradient&gt;")}} values now support multi-position color stop syntax, e.g. <code>yellow 25%, yellow 50%</code> can now be written <code>yellow 25% 50%</code> ({{bug(1352643)}}).</li>
 <li>The {{cssxref("text-transform")}} property now accepts the <code>full-size-kana</code> value ({{bug(1498148)}}).</li>
 <li>Support added for {{cssxref("appearance", "-webkit-appearance")}} to alleviate associated web compat issues ({{bug(1368555)}}).</li>
 <li>Closely associated with the above update, we've also removed most of the Firefox-specific <code>-moz-appearance</code> values ({{bug(1496720)}}).</li>
 <li>{{cssxref("display")}}: <code>list-item</code> is now supported on {{htmlelement("legend")}} elements ({{bug(1486602)}}).</li>
 <li>SVG <code>path()</code>s, as usable in {{cssxref("offset-path")}}, are now animatable ({{bug(1486094)}}).</li>
 <li>If a selector chain or group includes a <code>-webkit-</code>prefixed pseudo-element, that pseudo-element no longer invalidates it (see {{bug(1424106)}} for the details, and {{bug(1486325)}} for enabling this feature).</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li>The non-standard <a href="/en-US/docs/Mozilla/Gecko/Chrome/CSS/display-xul"><code style="white-space: nowrap;">-moz-box</code> and <code style="white-space: nowrap;">-moz-inline-box</code></a> {{CSSxRef("display")}} values have been hidden from web content ({{bug(1496961)}}).</li>
 <li>The non-standard {{CSSxRef("::-moz-tree")}} <a href="/en-US/docs/Web/CSS/Pseudo-elements" style="white-space: nowrap;">pseudo-elements</a> have been hidden from web content ({{bug(1496961)}}).</li>
 <li>The <code>layout.css.filters.enabled</code> preference has been removed; <a href="/en-US/docs/Web/CSS/Filter_Effects">CSS filters</a> can no longer be disabled ({{bug(1408841)}}).</li>
 <li>A previous change — to swap the values of the 2-value {{cssxref("overflow")}} syntax so block is specified first and inline second ({{bug(1481866)}}) — has been reverted ({{bug(1492567)}}). See <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1481866#c14">Bug 1481866 comment 14</a> for why.</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The TC39 <a href="https://github.com/tc39/proposal-well-formed-stringify">Well-formed JSON.stringify</a> proposal has been implemented, to prevent {{jsxref("JSON.stringify")}} from returning ill-formed Unicode strings ({{bug(1469021)}}).</li>
 <li>Proxied functions can now be passed to {{jsxref("Function.prototype.toString")}}<code>.call()</code> ({{bug(1440468)}}).</li>
 <li>In the {{jsxref("WebAssembly.Global")}} constructor, if no value is specified a typed 0 value is used. This is specified by the <a href="https://webassembly.github.io/spec/js-api/#defaultvalue"><code>DefaultValue</code> algorithm</a> ({{bug(1490286)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="DOM">DOM</h4>

<ul>
 <li>A number of changes related to the {{domxref("Fullscreen_API", "Fullscreen API", "", "1")}} have been implemented:
  <ul>
   <li>The API has been unprefixed ({{bug(1269276)}}).</li>
   <li>The {{domxref("Element.requestFullscreen()")}} and {{domxref("Document.exitFullscreen()")}} methods both now return a {{jsxref("Promise")}}, which is resolved when the mode change is complete ({{bug(1188256)}} and {{bug(1491212)}}).</li>
   <li>Previously, {{domxref("fullscreenchange")}} and {{domxref("fullscreenerror")}} events were dispatched to the {{domxref("Document")}} first, then the {{domxref("Element")}}. This has been reversed so that the element gets the event first. This matches the latest specification as well as the behavior of Google Chrome ({{bug(1375319)}}).</li>
  </ul>
 </li>
 <li>The {{domxref("WebVR_API", "WebVR API", "", "1")}} (1.1) is now re-enabled in macOS ({{bug(1476091)}}).</li>
 <li>{{domxref("Window.screenLeft")}} and {{domxref("Window.screenTop")}} have been implemented, as aliases of {{domxref("Window.screenX")}} and {{domxref("Window.screenY")}} ({{bug(1498860)}}).</li>
 <li>The {{domxref("XMLHttpRequest.getAllResponseHeaders()")}} method now returns header names all in lowercase, as per spec ({{bug(1398718)}}).</li>
 <li>The legacy <code>HTMLAllCollection</code> interface has been updated as per recent <a href="https://html.spec.whatwg.org/multipage/common-dom-interfaces.html#htmlallcollection">spec updates</a> ({{bug(1398354)}}).</li>
 <li>{{domxref("Navigator.buildID")}} now returns a fixed timestamp as a privacy measure ({{bug(583181)}}).</li>
 <li>The following {{domxref("Document.execCommand()")}} UI feature commands have been disabled by default ({{bug(1490641)}}, see also <a href="https://www.fxsitecompat.com/en-CA/docs/2018/firefox-specific-html-editing-ui-has-been-disabled-by-default/">Firefox-specific HTML editing UI has been disabled by default</a> for more details):
  <ul>
   <li><code>enableObjectResizing</code></li>
   <li><code>enableInlineTableEditing</code></li>
   <li><code>enableAbsolutePositionEditor</code></li>
  </ul>
 </li>
</ul>

<h4 id="Service_workers">Service workers</h4>

<ul>
 <li>The {{domxref("ServiceWorkerContainer.startMessages()")}} method has been implemented ({{bug(1263734)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The {{domxref("PannerNode.refDistance")}}, {{domxref("PannerNode.maxDistance")}}, {{domxref("PannerNode.rolloffFactor")}}, and {{domxref("PannerNode.coneOuterGain")}} properties now correctly throw exceptions when set to values outside their accepted ranges ({{bug(1487963)}}).</li>
 <li>{{domxref("RTCRtpEncodingParameters")}} settings changed via {{domxref("RTCRtpSender.setParameters()")}} used to not update if the changes were made during a call. They will now update live, without renegotiation ({{bug(1253499)}}).</li>
 <li>{{domxref("RTCIceCandidateStats.relayProtocol")}} has been implemented — this is the standardized version of {{domxref("RTCIceCandidateStats.mozLocalTransport")}}, which has now been deprecated ({{bug(1435789)}}).</li>
 <li>Automatic Gain Control (AGC) is now enabled by default; this can be changed using the preference <code>media.getusermedia.agc_enabled</code> ({{bug(1496714)}}).</li>
</ul>

<h4 id="Removals_3">Removals</h4>

<ul>
 <li>The {{domxref("Window.event")}} property, added in Firefox 63 to aid with web compat issues, has been put behind a pref (<code>dom.window.event.enabled</code>) and disabled by default in release versions for now due to other issues that have been uncovered ({{bug(1493869)}}). Note that this was actually done late in the Firefox 63 release cycle, but we are mentioning it here just in case.</li>
 <li>The {{domxref("LocalMediaStream")}} interface and its <code>stop()</code> method have been removed ({{bug(1258143)}}). This method is no longer available with the deprecation of <code>LocalMediaStream</code>. See {{SectionOnPage("/en-US/docs/Web/API/MediaStreamTrack/stop", "Stopping a video stream")}} to learn how to stop an entire stream.</li>
 <li>The <code>AudioStreamTrack</code> and <code>VideoStreamTrack</code> interfaces have been removed, as both have been deprecated for some time ({{bug(1377146)}}). Their functionality has been merged into {{domxref("MediaStreamTrack")}}; tracks are now identified by the value of their {{domxref("MediaStreamTrack.kind", "kind")}} property, such as <code>audio</code> or <code>video</code>.</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li>The Symantec CA Distrust plan has been implemented (see {{bug(1409257)}}; see also the <a href="https://groups.google.com/forum/#!topic/mozilla.dev.security.policy/FLHRT79e3XE/discussion">Mozilla’s Plan for Symantec Roots</a> discussion for more details).</li>
 <li>{{httpheader("Referrer-Policy")}} can now be used to govern resources fetched via stylesheets ({{bug(1330487)}}) — see {{SectionOnPage("/en-US/docs/Web/HTTP/Headers/Referrer-Policy", "Integration with CSS")}} for more information.</li>
</ul>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<h4 id="API_changes">API changes</h4>

<ul>
 <li>Deprecated command end-points without the <code>Marionette:</code>, <code>L10n:</code>, or <code>Addon:</code> prefix (including <code>singeTap</code>) have been removed ({{bug(1504478)}}, {{bug(1504940)}}).</li>
</ul>

<h4 id="Bug_fixes">Bug fixes</h4>

<ul>
 <li>Synthesized <code>Shift</code> key events by using <code>WebDriver:PerformActions</code> didn't result in capitalized letters ({{bug(1405370)}}).</li>
 <li><code>WebDriver:Navigate</code> could cause an infinite hang if the tab's underlying content process is changed multiple times during that navigation ({{bug(1504807)}}).</li>
 <li>To improve the performance, and to reduce the memory footprint of Firefox the default page to be loaded for a new tab or window is no longer <code>about:newtab</code> but <code>about:blank</code> ({{bug(1506643)}}).</li>
 <li>The content blocking introduction panel, which was shown on various web pages and caused element interactions to fail is disabled by default now ({{bug(1488826)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes_2">API changes</h3>

<h4 id="Menus">Menus</h4>

<ul>
 <li>A new API, <code>{{WebExtAPIRef("menus.overrideContext()")}}</code>, can be called from the <code>contextmenu</code> DOM event to set a custom context menu in extension pages. This API allows extensions to hide all default Firefox menu items in favor of providing a custom context menu UI. This context menu can consist of multiple top-level menu items from the extension, and may optionally include tab or bookmark context menu items from other extensions. See <a href="https://blog.mozilla.org/addons/2018/11/08/extensions-in-firefox-64/#cm">this blog post</a> for more details.

  <ul>
   <li><code>{{WebExtAPIRef("menus.overrideContext()")}}</code> was implemented in ({{bug(1280347)}}).</li>
   <li>The <code>showDefaults: false</code> option, which can be used to hide the default context menu options, was implemented in ({{bug(1367160)}}).</li>
   <li><code>documentURLPatterns</code> can now be used to match a <code>moz-extension://</code> document URL, even if <code>{{WebExtAPIRef("menus.overrideContext()")}}</code> is used. This way, it can reliably be used to restrict custom menu items to certain documents ({{bug(1498896)}}).</li>
  </ul>
 </li>
 <li>You can now restrict where context menus can appear in an add-on using the new <code>viewTypes</code> property in {{WebExtAPIRef("menus.create()")}} and {{WebExtAPIRef("menus.update()")}} ({{bug(1416839)}}).</li>
 <li>{{WebExtAPIRef("menus.update()")}} can now be used to update the icon of an existing menu item ({{bug(1414566)}}).</li>
 <li>Extensions can now detect which mouse button was used when a menu item was clicked — this can be found using the new <code>button</code> property of {{WebExtAPIRef("menus.OnClickData")}} ({{bug(1469148)}}).</li>
</ul>

<h4 id="Windows">Windows</h4>

<ul>
 <li>The {{WebExtAPIRef("windows.create()")}} method now has a new option available — <code>cookieStoreId</code> — which specifies the <code>CookieStoreId</code> to use for all tabs that were created when the window is opened ({{bug(1393570)}}).</li>
</ul>

<h4 id="Privacy">Privacy</h4>

<ul>
 <li>The {{WebExtAPIRef("privacy.websites")}} <code>cookieConfig</code> property is an object that can accept a <code>behavior</code> property — this property can now take a new value, <code>reject_trackers</code>, which instructs the extension to reject tracking cookies ({{bug(1493057)}}).</li>
</ul>

<h4 id="devtools.panels_API">devtools.panels API</h4>

<ul>
 <li>The <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/devtools.panels/elements">devtools.panels.elements</a></code> <code>Sidebar.setPage()</code> method is now supported ({{bug(1398734)}}).</li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<ul>
 <li>The new <code>pinned</code> property of the <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/page_action">page_action</a></code> manifest key enables extensions to control whether their page actions should be pinned to the location bar on install or not ({{bug(1494135)}}).</li>
 <li>In native manifests on Windows, the 32-bit registry view (<a class="external external-icon" href="https://en.wikipedia.org/wiki/WoW64#Registry_and_file_system" rel="noopener">Wow6432Node)</a> will be checked first for registry keys, followed by the "native" registry view; you should use whichever is appropriate for your application ({{bug(1494709)}}).</li>
 <li>The <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/chrome_settings_overrides">chrome_settings_overrides</a></code> field's <code>search_provider</code> object can now include new properties — <code>suggest_url</code> and <code>suggest_url_post_params</code> ({{bug(1486819)}}), and <code>search_url_post_params</code>.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks release post: <a href="https://hacks.mozilla.org/2018/12/firefox-64-released/">Firefox 64 Released</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/64/">Site compatibility for Firefox 64</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(63)}}</p>
